# WinUIEx

A set of extension methods and classes to fill some gaps in WinUI 3, mostly around windowing and unit testing.

### NuGet Packages:

  - [WinUIEX](https://www.nuget.org/packages/WinUIEx/)
  - [WinUIEX.TestTools](https://www.nuget.org/packages/WinUIEx.TestTools/)
  - [WinUIEX.TestTools.MSTest](https://www.nuget.org/packages/WinUIEx.TestTools.MSTest/)

### Features

  - [Window Extension methods](concepts/WindowExtensions.md)
  - [HWND Window Handle Extensions methods](concepts/HwndExtensions.md)
  - [Extended `WindowEx` Window class](concepts/WindowEx.md)
  - [UI Test Tooling for easy UI Testing](concepts/UITests.md)
  - [Splash screen](concepts/Splashscreen.md)
  - [OAuth Web Authenticator](concepts/WebAuthenticator.md)


And more to come...

### Conceptual Docs

Read the [Conceptual docs here](concepts/index.md)

## Sponsoring

If you like WinUIEx and use it a lot, consider sponsoring me. Anything helps and encourages me to keep going.

See here for details: https://github.com/sponsors/dotMorten


## Getting started:

Read the [Overview](concepts/index.md) notes

![image](https://user-images.githubusercontent.com/1378165/171925868-5783b70d-3942-4911-8c77-86df696a7b97.png)

